package com.tmax.openframe.variable.group;

import ch.obermuhlner.math.big.BigDecimalMath;
import java.math.*;
import java.text.DecimalFormat;
import java.util.*;
import java.util.function.BiFunction;
import lombok.*;
import org.apache.commons.lang3.StringUtils;

/** 
 * <p>This source code was generated by COBOL to JAVA migrator</p>
 */
public @AllArgsConstructor @NoArgsConstructor @Builder(builderClassName = "builder") class OIVPINFO_WS_RAW_TIME {
    public @Getter @Setter int WS_TIME;

    public OIVPINFO_WS_TIME_PARTS getWS_TIME_PARTS() {
        return OIVPINFO_WS_TIME_PARTS.builder().AAA(getAAA())
                .WS_HRS(getWS_HRS()).WS_MIN(getWS_MIN()).BBB(getBBB()).build();
    }

    public void setWS_TIME_PARTS(String source) {
        setAAA(source.substring(0, 1));
        setWS_HRS(Integer.parseInt(source.substring(1, 3)));
        setWS_MIN(Integer.parseInt(source.substring(3, 5)));
        setBBB(source.substring(5, 7));
    }

    public void setWS_TIME_PARTS(OIVPINFO_WS_TIME_PARTS source) {
        setWS_TIME_PARTS(source.toString());
    }

    public String getAAA() {
        return intFormatWithoutSign.apply((long) getWS_TIME(), "0000000")
                .substring(0, 1);
    }

    public void setAAA(String source) {
        setWS_TIME(Integer.parseInt(source
                + intFormatWithoutSign.apply((long) getWS_HRS(), "00")
                + intFormatWithoutSign.apply((long) getWS_MIN(), "00")
                + getBBB()));
    }

    public int getWS_HRS() {
        return Integer.parseInt(intFormatWithoutSign.apply((long) getWS_TIME(),
                "0000000").substring(1, 3));
    }

    public void setWS_HRS(int source) {
        setWS_TIME(Integer.parseInt(getAAA()
                + intFormatWithoutSign.apply((long) source, "00")
                + intFormatWithoutSign.apply((long) getWS_MIN(), "00")
                + getBBB()));
    }

    public int getWS_MIN() {
        return Integer.parseInt(intFormatWithoutSign.apply((long) getWS_TIME(),
                "0000000").substring(3, 5));
    }

    public void setWS_MIN(int source) {
        setWS_TIME(Integer.parseInt(getAAA()
                + intFormatWithoutSign.apply((long) getWS_HRS(), "00")
                + intFormatWithoutSign.apply((long) source, "00") + getBBB()));
    }

    public String getBBB() {
        return intFormatWithoutSign.apply((long) getWS_TIME(), "0000000")
                .substring(5);
    }

    public void setBBB(String source) {
        setWS_TIME(Integer
                .parseInt(getAAA()
                        + intFormatWithoutSign.apply((long) getWS_HRS(), "00")
                        + intFormatWithoutSign.apply((long) getWS_MIN(), "00")
                        + source));
    }

    private final static BiFunction<Long, String, String> intFormatWithoutSign = (
            value, format) -> {
        DecimalFormat nf = new DecimalFormat();
        nf.setNegativePrefix("");
        nf.applyPattern(format);
        return nf.format(value);
    };

    public String getStringWS_TIME() {
        return intFormatWithoutSign.apply((long) WS_TIME, "0000000");
    }

    @Override
    public String toString() {
        return getStringWS_TIME();
    }
}
